
#include <MSFS\MSFS.h>
#include <MSFS\MSFS_WindowsTypes.h>
#include <SimConnect.h>
//#include <MSFS\MSFS_Network.h>

#include "Module.h"
//#include <regex>


int     quit = 0;
HANDLE  ca_hSimConnect;
int     current = 0;

static enum REQUESTS {
    REQUEST_ENUMERATE_INPUT_EVENTS,

};

static enum GROUP_ID {
    GROUP_0
};

static enum INPUT_ID {
    INPUT_SLIDER,
    INPUT_XAXIS,
    INPUT_YAXIS,
    INPUT_ZAXIS,
    INPUT_LZAXIS,
    INPUT_RXAXIS,
    INPUT_RYAXIS,
    INPUT_RZAXIS,
    INPUT_TRIGGERS,
    INPUT_TRIGGER,
    INPUT_LTRIGGER,
    INPUT_RTRIGGER,
    INPUT_HAT,
};

static enum EVENT_ID {
    EVENT_FLIGHT_LOADED,
    EVENT_AIRCRAFT_LOADED,
    EVENT_RECUR_FRAME,
    EVENT_PAUSEEX1,
    EVENT_SLIDER,
    EVENT_XAXIS,
    EVENT_YAXIS,
    EVENT_ZAXIS,
    EVENT_LZAXIS,
    EVENT_RXAXIS,
    EVENT_RYAXIS,
    EVENT_RZAXIS,
    EVENT_TRIGGERS,
    EVENT_TRIGGER,
    EVENT_LTRIGGER,
    EVENT_RTRIGGER,
    EVENT_HAT,
};

void CALLBACK MyDispatchProcJ(SIMCONNECT_RECV* pData, DWORD cbData, void* pContext);

extern "C" MSFS_CALLBACK void module_init(void)
{

    ca_hSimConnect = 0;
    HRESULT hr = SimConnect_Open(&ca_hSimConnect, "JOYSTICK EVENTS", nullptr, 0, 0, 0);
    if (hr != S_OK)
    {
        fprintf(stderr, "JOYSTICK EVENTS: Could not open SimConnect connection.\n");
        return;
    }
    else {
		fprintf(stderr, "JOYSTICK EVENTS: SimConnect connection opened.\n");
    }

    hr = SimConnect_SubscribeToSystemEvent(ca_hSimConnect, EVENT_RECUR_FRAME, "frame");
    if (hr != S_OK)
    {
        fprintf(stderr, "JOYSTICK EVENTS: Could not subscripte to \"Frame\" system event.\n");
        return;
    }

    hr = SimConnect_CallDispatch(ca_hSimConnect, MyDispatchProcJ, nullptr);
    if (hr != S_OK)
    {
        fprintf(stderr, "JOYSTICK EVENTS: Could not set dispatch proc.\n");
        return;
    }

    // Set up some private events
    hr = SimConnect_MapClientEventToSimEvent(ca_hSimConnect, EVENT_SLIDER);
    hr = SimConnect_MapClientEventToSimEvent(ca_hSimConnect, EVENT_XAXIS);
    hr = SimConnect_MapClientEventToSimEvent(ca_hSimConnect, EVENT_YAXIS);
    hr = SimConnect_MapClientEventToSimEvent(ca_hSimConnect, EVENT_ZAXIS);
    hr = SimConnect_MapClientEventToSimEvent(ca_hSimConnect, EVENT_LZAXIS);
    hr = SimConnect_MapClientEventToSimEvent(ca_hSimConnect, EVENT_RXAXIS);
    hr = SimConnect_MapClientEventToSimEvent(ca_hSimConnect, EVENT_RYAXIS);
    hr = SimConnect_MapClientEventToSimEvent(ca_hSimConnect, EVENT_RZAXIS);
    hr = SimConnect_MapClientEventToSimEvent(ca_hSimConnect, EVENT_TRIGGERS);
	hr = SimConnect_MapClientEventToSimEvent(ca_hSimConnect, EVENT_TRIGGER);
	hr = SimConnect_MapClientEventToSimEvent(ca_hSimConnect, EVENT_LTRIGGER);
	hr = SimConnect_MapClientEventToSimEvent(ca_hSimConnect, EVENT_RTRIGGER);
    hr = SimConnect_MapClientEventToSimEvent(ca_hSimConnect, EVENT_HAT);

    // Add all the private events to a notifcation group
    hr = SimConnect_AddClientEventToNotificationGroup(ca_hSimConnect, GROUP_0, EVENT_SLIDER);
    hr = SimConnect_AddClientEventToNotificationGroup(ca_hSimConnect, GROUP_0, EVENT_XAXIS);
    hr = SimConnect_AddClientEventToNotificationGroup(ca_hSimConnect, GROUP_0, EVENT_YAXIS);
    hr = SimConnect_AddClientEventToNotificationGroup(ca_hSimConnect, GROUP_0, EVENT_ZAXIS);
    hr = SimConnect_AddClientEventToNotificationGroup(ca_hSimConnect, GROUP_0, EVENT_LZAXIS);
    hr = SimConnect_AddClientEventToNotificationGroup(ca_hSimConnect, GROUP_0, EVENT_RXAXIS);
    hr = SimConnect_AddClientEventToNotificationGroup(ca_hSimConnect, GROUP_0, EVENT_RYAXIS);
    hr = SimConnect_AddClientEventToNotificationGroup(ca_hSimConnect, GROUP_0, EVENT_RZAXIS);
	hr = SimConnect_AddClientEventToNotificationGroup(ca_hSimConnect, GROUP_0, EVENT_TRIGGERS);
	hr = SimConnect_AddClientEventToNotificationGroup(ca_hSimConnect, GROUP_0, EVENT_TRIGGER);
	hr = SimConnect_AddClientEventToNotificationGroup(ca_hSimConnect, GROUP_0, EVENT_LTRIGGER);
	hr = SimConnect_AddClientEventToNotificationGroup(ca_hSimConnect, GROUP_0, EVENT_RTRIGGER);
    hr = SimConnect_AddClientEventToNotificationGroup(ca_hSimConnect, GROUP_0, EVENT_HAT);

    // Set a high priority for the group
    hr = SimConnect_SetNotificationGroupPriority(ca_hSimConnect, GROUP_0, SIMCONNECT_GROUP_PRIORITY_HIGHEST);

    // Map input events to the private client events
    hr = SimConnect_MapInputEventToClientEvent(ca_hSimConnect, INPUT_SLIDER, "joystick:0:slider", EVENT_SLIDER);
    hr = SimConnect_MapInputEventToClientEvent(ca_hSimConnect, INPUT_XAXIS, "joystick:0:XAxis", EVENT_XAXIS);
    hr = SimConnect_MapInputEventToClientEvent(ca_hSimConnect, INPUT_YAXIS, "joystick:0:YAxis", EVENT_YAXIS);
    hr = SimConnect_MapInputEventToClientEvent(ca_hSimConnect, INPUT_ZAXIS, "joystick:0:ZAxis", EVENT_ZAXIS);
    hr = SimConnect_MapInputEventToClientEvent(ca_hSimConnect, INPUT_LZAXIS, "joystick:0:LZAxis", EVENT_LZAXIS);
    hr = SimConnect_MapInputEventToClientEvent(ca_hSimConnect, INPUT_RXAXIS, "joystick:0:RXAxis", EVENT_RXAXIS);
    hr = SimConnect_MapInputEventToClientEvent(ca_hSimConnect, INPUT_RYAXIS, "joystick:0:RYAxis", EVENT_RYAXIS);
    hr = SimConnect_MapInputEventToClientEvent(ca_hSimConnect, INPUT_RZAXIS, "joystick:0:RZAxis", EVENT_RZAXIS);
    hr = SimConnect_MapInputEventToClientEvent(ca_hSimConnect, INPUT_TRIGGERS, "joystick:0:Triggers", EVENT_TRIGGERS);
	hr = SimConnect_MapInputEventToClientEvent(ca_hSimConnect, INPUT_TRIGGER, "joystick:0:Trigger", EVENT_TRIGGER);
    hr = SimConnect_MapInputEventToClientEvent(ca_hSimConnect, INPUT_LTRIGGER, "joystick:0:LTrigger", EVENT_LTRIGGER);
	hr = SimConnect_MapInputEventToClientEvent(ca_hSimConnect, INPUT_RTRIGGER, "joystick:0:RTrigger", EVENT_RTRIGGER);
    hr = SimConnect_MapInputEventToClientEvent(ca_hSimConnect, INPUT_HAT, "joystick:0:POV", EVENT_HAT);

    // Turn all the joystick events off
    hr = SimConnect_SetInputGroupState(ca_hSimConnect, INPUT_SLIDER, SIMCONNECT_STATE_ON); 
    hr = SimConnect_SetInputGroupState(ca_hSimConnect, INPUT_XAXIS, SIMCONNECT_STATE_ON);
    hr = SimConnect_SetInputGroupState(ca_hSimConnect, INPUT_YAXIS, SIMCONNECT_STATE_ON);
    hr = SimConnect_SetInputGroupState(ca_hSimConnect, INPUT_ZAXIS, SIMCONNECT_STATE_ON);
    hr = SimConnect_SetInputGroupState(ca_hSimConnect, INPUT_LZAXIS, SIMCONNECT_STATE_ON);
    hr = SimConnect_SetInputGroupState(ca_hSimConnect, INPUT_RYAXIS, SIMCONNECT_STATE_ON);
    hr = SimConnect_SetInputGroupState(ca_hSimConnect, INPUT_RXAXIS, SIMCONNECT_STATE_ON);
    hr = SimConnect_SetInputGroupState(ca_hSimConnect, INPUT_RZAXIS, SIMCONNECT_STATE_ON);
	hr = SimConnect_SetInputGroupState(ca_hSimConnect, INPUT_TRIGGERS, SIMCONNECT_STATE_ON);
	hr = SimConnect_SetInputGroupState(ca_hSimConnect, INPUT_TRIGGER, SIMCONNECT_STATE_ON);
	hr = SimConnect_SetInputGroupState(ca_hSimConnect, INPUT_LTRIGGER, SIMCONNECT_STATE_ON);
	hr = SimConnect_SetInputGroupState(ca_hSimConnect, INPUT_RTRIGGER, SIMCONNECT_STATE_ON);
    hr = SimConnect_SetInputGroupState(ca_hSimConnect, INPUT_HAT, SIMCONNECT_STATE_ON);

    /*SimConnect_EnumerateInputEvents(
        ca_hSimConnect,
        REQUEST_ENUMERATE_INPUT_EVENTS
    );*/
}

void CALLBACK MyDispatchProcJ(SIMCONNECT_RECV* pData, DWORD cbData, void* pContext)
{
    HRESULT hr;

    switch (pData->dwID)
    {
    case SIMCONNECT_RECV_ID_EVENT_FRAME:
    {
        SIMCONNECT_RECV_EVENT_FRAME* evt = (SIMCONNECT_RECV_EVENT_FRAME*)pData;

        switch (evt->uEventID)
        {
        case EVENT_RECUR_FRAME:
            break;
        }
    }
    case SIMCONNECT_RECV_ID_EVENT:
    {
        SIMCONNECT_RECV_EVENT* evt = (SIMCONNECT_RECV_EVENT*)pData;

        switch (evt->uEventID)
        {
        case EVENT_SLIDER:
            fprintf(stderr, "JOYSTICK EVENTS: Slider value:%d", evt->dwData);
            break;
        case EVENT_XAXIS:
            fprintf(stderr, "JOYSTICK EVENTS: X Axis value:%d", evt->dwData);
            break;
        case EVENT_YAXIS:
            fprintf(stderr, "JOYSTICK EVENTS: Y Axis value:%d", evt->dwData);
            break;
        case EVENT_ZAXIS:
            fprintf(stderr, "JOYSTICK EVENTS: Z Axis value:%d", evt->dwData);
            break;
        case EVENT_LZAXIS:
            fprintf(stderr, "JOYSTICK EVENTS: Rotate Z axis value:%d", evt->dwData);
            break;
        case EVENT_RXAXIS:
            fprintf(stderr, "JOYSTICK EVENTS: Rotate Z axis value:%d", evt->dwData);
            break;
        case EVENT_RYAXIS:
            fprintf(stderr, "JOYSTICK EVENTS: Rotate Z axis value:%d", evt->dwData);
            break;
        case EVENT_RZAXIS:
            fprintf(stderr, "JOYSTICK EVENTS: Rotate Z axis value:%d", evt->dwData);
            break;
		case EVENT_TRIGGERS:
			fprintf(stderr, "JOYSTICK EVENTS: Triggers value:%d", evt->dwData);
			break;
		case EVENT_TRIGGER:
			fprintf(stderr, "JOYSTICK EVENTS: Trigger value:%d", evt->dwData);
			break;
		case EVENT_LTRIGGER:
			fprintf(stderr, "JOYSTICK EVENTS: LTrigger value:%d", evt->dwData);
			break;
		case EVENT_RTRIGGER:
			fprintf(stderr, "JOYSTICK EVENTS: RTrigger value:%d", evt->dwData);
			break;
        case EVENT_HAT:
            fprintf(stderr, "JOYSTICK EVENTS: Hat value:%d", evt->dwData);
            break;
        default:
            break;
        }
        break;
    }


    case SIMCONNECT_RECV_ID_QUIT:
    {
        quit = 1;
        break;
    }

    case SIMCONNECT_RECV_ID_ENUMERATE_INPUT_EVENTS:
    {
        SIMCONNECT_RECV_ENUMERATE_INPUT_EVENTS* evt = (SIMCONNECT_RECV_ENUMERATE_INPUT_EVENTS*)pData;
        
        for (int i = 0; i < evt->dwArraySize; i++) {
            SIMCONNECT_INPUT_EVENT_DESCRIPTOR descr = (SIMCONNECT_INPUT_EVENT_DESCRIPTOR)evt->rgData[i];
            fprintf(stderr, "JOYSTICK EVENTS: input %s %lu %lu", descr.Name, descr.eType, descr.Hash);
        }

        break;
    }

    default:
        fprintf(stderr, "JOYSTICK EVENTS: UNKNOWN REQUEST %lu", pData->dwID);
        break;
    }
}
